package com.home.cloning;

public class CloneViaOverRiding implements Cloneable {
	int a;
	double b;

	// clone() is now overridden and is public.
	public Object getClone() {
		try {
			// call clone in Object.
			return super.clone();
		} catch (CloneNotSupportedException e) {
			System.out.println("Cloning not allowed.");
			return this;
		}
	}
}
